
! Cal_Date_String_v1_1
! Program generates calendar date strings MM/DD/YYY beginning at 01/01/ of BeginYear
! to 12/31/ of EndYear and saves results in c:\temp\Cal_Dates
! June 9, 1997
!
!January 14, 2005 version Cal_Date_Str was modified to include century convention 
!to leap year.


PROGRAM Cal_Date_Str_v1_1

IMPLICIT NONE

INTEGER :: BeginYear, EndYear
INTEGER :: I, J, Number_of_Days, Day, MthDays, OpenStatus
CHARACTER (14) :: Date_Str (50000)
CHARACTER :: Day_Str*2, Month_Str*2, Year_Str*4, Answer*1

Input_Loop: DO
WRITE (*,*) "Results Will Be Placed In C:\TEMP\CAL_DATES.txt"
WRITE (*,*) 
WRITE (*,*) "Enter first year for calendar dates (i.e. 1893)" 
	READ (*,*) BeginYear
WRITE (*,*) "Enter last year for calendar dates (i.e. 1994)"
	READ (*,*) EndYear

OPEN (UNIT=10, FILE="C:\TEMP\CAL_DATES.txt", STATUS="NEW", ACTION="WRITE", POSITION="REWIND", &
	IOSTAT=OpenStatus)
		IF (OpenStatus>0) STOP "Cannot Open File"

Number_of_Days=0
DO I=BeginYear, EndYear
	WRITE (Year_Str,'(I4)') I
		DO J=1,12
		WRITE (Month_Str,'(I2)') J
			IF (J<10) Month_Str(1:1)="0"
	!Select number of days in month J
		Days_in_Month: SELECT CASE (J)
		CASE (4)
			MthDays=30
		CASE (6)
			MthDays=30
		CASE (9)
			MthDays=30
		CASE (11)
			MthDays=30
		CASE DEFAULT
			MthDays=31
		END SELECT Days_in_Month

         IF (J==2) MthDays=28
         IF (J==2 .AND. MOD(I,4)==0 .AND. MOD(I,100) .NE. 0) MthDays=29 !Leap Year 
		 IF (J==2 .AND. MOD(I,400)==0) MthDays=29 !Leap Year Exception
			

			 		DO Day=1, MthDays
						Number_of_Days=Number_of_Days+1
						WRITE (Day_Str,'(I2)') Day
							IF (Day<10) Day_Str(1:1)="0"
						Date_Str(Number_of_Days)(1:14)=Month_Str//"/"//Day_Str//"/"//Year_Str//" -99"
						WRITE (UNIT=10,FMT=100) Date_Str(Number_of_Days)
		100 FORMAT (A14)
					END DO
		!pause
		END DO
END DO

CLOSE (UNIT=10)

WRITE (*,*) "Process another data set Y/N"
		READ (*,*) Answer
		IF (Answer=="N".OR. Answer=="n") EXIT	
	WRITE (*,*)

END DO Input_Loop
 
END PROGRAM Cal_Date_Str_v1_1 


